'From Croquet1.0beta of 11 April 2006 [latest update: #1] on 28 July 2008 at 10:46:51 am'!

!CParser methodsFor: 'expression types' stamp: 'ar 3/7/2006 12:27'!
method: doit context: ctxt encoder: encoderToUse
	" pattern [ | temporaries ] block => MethodNode."

	| sap blk prim temps messageComment methodNode |
	properties := MethodProperties new.
	encoder := encoderToUse.
	sap := self pattern: doit inContext: ctxt.
	"sap={selector, arguments, precedence}"
	encoder selector: (sap at: 1).
	(sap at: 2) do: [:argNode | argNode isArg: true].
	temps := self temporaries.
	messageComment := currentComment.
	currentComment := nil.
	doit ifFalse:[self properties].
	prim := 0.
	properties ifNotNil:[
		prim := properties at: #primitiveIndex ifAbsent:[0].
		"don't preserve primitive index"
		properties removeKey: #primitiveIndex ifAbsent:[].
	].
	self statements: #() innerBlock: doit.
	blk := parseNode.
	doit ifTrue: [blk returnLast]
		ifFalse: [blk returnSelfIfNoOther: encoder].
	hereType == #doIt ifFalse: [^self expected: 'Nothing more'].
	self interactive ifTrue: [self removeUnusedTemps].
	methodNode := self newMethodNode comment: messageComment.
	^ methodNode
		selector: (sap at: 1)
		arguments: (sap at: 2)
		precedence: (sap at: 3)
		temporaries: temps
		block: blk
		encoder: encoder
		primitive: prim
		properties: properties! !

!CParser methodsFor: 'events' stamp: 'ar 3/26/2004 15:45'!
blockTrigger
	"Parse a block trigger"
	| methodNode method |
	self advance.
	self statements: #() innerBlock: false.
	(self match: #rightBracket) ifFalse: [^self expected: 'Period or right bracket'].
	methodNode := self newMethodNode.
	methodNode
		selector: #blockTrigger
		arguments: #()
		precedence: 1
		temporaries: #()
		block: parseNode
		encoder: encoder
		primitive: 0
		properties: nil.
	method := methodNode generate: #(0 0 0 0).
	^method
! !


!FutureNode methodsFor: 'code generation (closures)' stamp: 'eem 7/17/2008 19:58'!
analyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>"
	{ receiver. futureDelta }, (futureArgs ifNil: [#()]) do:
		[:node|
		node == nil ifFalse:
			[node analyseTempsWithin: scopeBlock rootNode: rootNode]]! !

FutureNode removeSelector: #analyseTempsWithin:forValue:encoder:!
CParser removeSelector: #pattern:inContext:!
